% Including wages
ymean=36.20;
xmean=[16.57 -40.88 4.85 42.31 10.88];
load('WBC.mat')
test=WBC>0;
averageNN=mean(sum(test,2)) % Answer=6
A=xlsread('Data Fogli Veldkamp.xls');
N1=3074;T1=6;
xcor=A(1:N1,18);
ycor=A(1:N1,19);
WD=zeros(N1,N1);
for i=1:N1
    for j=i+1:N1
        dist=sqrt((xcor(i,1)-xcor(j,1))^2+(ycor(i,1)-ycor(j,1))^2);
        WD(i,j)=dist;
        WD(j,i)=WD(i,j);
    end
end
M1=sum(isnan(A(N1+1:end,[3,4,5,10,11,16])),2); % Missing observations
M2=reshape(M1,N1,T1);
M3=sum(M2>0,2)==0;
N=sum(M3) %1569 full set of observations
Select=sum(M2>0,2)==0;
WD=WD(Select,Select);
W=zeros(N,N);
for i=1:N
    [B,Index]=sort(WD(:,i));
    for j=2:7 %skip 1=county itself
        W(i,Index(j))=1/6;
    end
end
Selectfull=[Select;Select;Select;Select;Select;Select;Select];
y=A(Selectfull,3);
x=A(Selectfull,[4,5,10,11,16]);
x(:,5)=x(:,5)/1000;
T=7;
clear Wy;
[nobs K]=size(x);
corrcoef(x(N+1:end,:))
px=K;
%Create WY and wx variables variables
Wy=y;
wx=x;
for t=1:T
    t1=(t-1)*N+1;t2=t*N;
    Wy(t1:t2,1)=W*y(t1:t2,1);
    wx(t1:t2,:)=W*x(t1:t2,:);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Common factors R=2 + spatial error %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf(1,' \n');
fprintf(1,'DSPD with PCs \n');
init = ['LFP(t-1)    ';'W*LFP(t-1)  ';
        'pc_urb      ';'pc_farm     ';
        'avg_educ    ';'pop_dens    ';
        'wages       ';'W*pc_urb    ';
        'W*pc_farm   ';'W*avg_educ  ';
        'W*pop_dens  ';'W*wages     ';
        'W*LFP(t)    ';'W*error     '];
lambda0 = 0.1;
gamma0  = 0.1;
rho0    = 0.6;
alpha0  = 0.1;
beta0   = zeros(10,1); %change3
start = [gamma0;rho0;beta0;lambda0;alpha0];
TolX=0.0001;
Y=reshape(y(N+1:end),N,T-1);
X = zeros(2+2*K,N,T-1); %change4
X(1,:,:) = reshape(y(1:end-N),N,T-1);
X(2,:,:) = reshape(Wy(1:end-N),N,T-1);
for i=1:K %change5
    X(i+2,:,:) = reshape(x(N+1:end,i),N,T-1);
    X(i+2+K,:,:) = reshape(wx(N+1:end,i),N,T-1);
end
R=2; % # number of CF
[beta,bcorr,Vbeta,gamma,f,exitflag,stats,resid] = SFactors(Y,W,W,X,R,start,TolX);
exitflag
resul=[beta-bcorr sqrt(diag(Vbeta)) (beta-bcorr)./sqrt(diag(Vbeta))]; % Note t-value excluding bcorrection
disp('             Coef      Sdev      t-stat')
disp([init,num2str(resul,'% 10.4f')])
disp('R2')
stats(1,1)
disp('LogL')
stats(3,1)
resul(6,1)*1000 % Coefficient pop-density in 3 more digits
resul(11,1)*1000 % Coefficient w*pop-density in 3 more digits

% Direct/Indirect effects
px=K;
btemp=beta-bcorr;
[npar dummy]=size(btemp);
beta  = btemp(3:npar-2,1);%%%%%
tau   = btemp(1,1); % Coef Y(t-1)
eta   = btemp(2,1); % Coef WY(t-1)
delta = btemp(npar-1,1); % Coef WY(t)
SS=((1-tau)*eye(N)-(delta+eta)*W)\eye(N);
dirind=zeros(px,3);
for p=1:px
        C=zeros(N,N);
        for i=1:N
            for j=1:N
                if (i==j) C(i,j)=beta(p);
                else C(i,j)=beta(p+px)*W(i,j);
                end
            end
        end
        SC=SS*C;
        dirind(p,1)=xmean(p)*100*sum(diag(SC))/(N*ymean); % average direct effect
        dirind(p,2)=xmean(p)*100*sum(sum(SC,2)-diag(SC))/(N*ymean); % average indirect effect
        dirind(p,3)=dirind(p,1)+dirind(p,2);        
end
dirind
sum(dirind)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ymean=36.20;
xmean=[16.57 -40.88 4.85 42.31];
load('WBC.mat')
A=xlsread('Data Fogli Veldkamp.xls');
N1=3074;T1=7;
M1=sum(isnan(A(:,[3,4,5,10,11])),2); % Missing observations
M2=reshape(M1,N1,T1);
Select=sum(M2>0,2)==0;
sum(Select) % 3066 full set of observations
Selectfull=[Select;Select;Select;Select;Select;Select;Select];
y=A(Selectfull,3);
px=4;
x=A(Selectfull,[4,5,10,11]);
W=normw(WBC(Select,Select));

% Set dimensions
T=7;
N=3066;

%Create WY and wx variables variables
Wy=y;
wx=x;
for t=1:T
    t1=(t-1)*N+1;t2=t*N;
    Wy(t1:t2,1)=W*y(t1:t2,1);
    wx(t1:t2,:)=W*x(t1:t2,:);
end
[nobs K]=size(x);
%%%%%% Common factors R=2 + spatial error %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf(1,' \n');
fprintf(1,'DSPD with PCs \n');
init = ['LFP(t-1)    ';'W*LFP(t-1)  ';
        'pc_urb      ';'pc_farm     ';
        'avg_educ    ';'pop_dens    ';
        'W*pc_urb    ';'W*pc_farm   ';
        'W*avg_educ  ';'W*pop_dens  ';
        'W*LFP(t)    ';'W*error     '];
lambda0 = 0.1;
gamma0  = 0.1;
rho0    = 0.6;
alpha0  = 0.1;
beta0   = zeros(8,1); %change3
start = [gamma0;rho0;beta0;lambda0;alpha0];
TolX=0.0001;
Y=reshape(y(N+1:end),N,T-1);
X = zeros(2+2*K,N,T-1); %change4
X(1,:,:) = reshape(y(1:end-N),N,T-1);
X(2,:,:) = reshape(Wy(1:end-N),N,T-1);
for i=1:K %change5
    X(i+2,:,:) = reshape(x(N+1:end,i),N,T-1);
    X(i+2+K,:,:) = reshape(wx(N+1:end,i),N,T-1);
end
R=2; % # number of CF
[beta,bcorr,Vbeta,gamma,f,exitflag,stats,resid] = SFactors(Y,W,W,X,R,start,TolX);
exitflag
resul=[beta-bcorr sqrt(diag(Vbeta)) (beta-bcorr)./sqrt(diag(Vbeta))]; % Note t-value excluding bcorrection
disp('             Coef      Sdev      t-stat')
disp([init,num2str(resul,'% 10.4f')])
disp('R2')
stats(1,1)
disp('LogL')
stats(3,1)
resul(6,1)*1000 % Coefficient pop-density in 3 more digits
resul(10,1)*1000 % Coefficient w*pop-density in 3 more digits

% Direct/Indirect effects
px=K;
btemp=beta-bcorr;
[npar dummy]=size(btemp);
beta  = btemp(3:npar-2,1);%%%%%
tau   = btemp(1,1); % Coef Y(t-1)
eta   = btemp(2,1); % Coef WY(t-1)
delta = btemp(npar-1,1); % Coef WY(t)
SS=((1-tau)*eye(N)-(delta+eta)*W)\eye(N);
dirind=zeros(px,3);
for p=1:px
        C=zeros(N,N);
        for i=1:N
            for j=1:N
                if (i==j) C(i,j)=beta(p);
                else C(i,j)=beta(p+px)*W(i,j);
                end
            end
        end
        SC=SS*C;
        dirind(p,1)=xmean(p)*100*sum(diag(SC))/(N*ymean); % average direct effect
        dirind(p,2)=xmean(p)*100*sum(sum(SC,2)-diag(SC))/(N*ymean); % average indirect effect
        dirind(p,3)=dirind(p,1)+dirind(p,2);        
end
dirind
sum(dirind)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% NO WX
%%%%%% Common factors R=2 + spatial error %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf(1,' \n');
fprintf(1,'DSPD with PCs \n');
init = ['LFP(t-1)    ';'W*LFP(t-1)  ';
        'pc_urb      ';'pc_farm     ';
        'avg_educ    ';'pop_dens    ';
        'W*LFP(t)    ';'W*error     '];
lambda0 = 0.1;
gamma0  = 0.1;
rho0    = 0.6;
alpha0  = 0.1;
beta0   = zeros(8,1); %change3
start = [gamma0;rho0;beta0;lambda0;alpha0];
TolX=0.0001;
Y=reshape(y(N+1:end),N,T-1);
X = zeros(2+K,N,T-1); %change4
X(1,:,:) = reshape(y(1:end-N),N,T-1);
X(2,:,:) = reshape(Wy(1:end-N),N,T-1);
for i=1:K %change5
    X(i+2,:,:) = reshape(x(N+1:end,i),N,T-1);
end
R=2; % # number of CF
[beta,bcorr,Vbeta,gamma,f,exitflag,stats,resid] = SFactors(Y,W,W,X,R,start,TolX);
exitflag
resul=[beta-bcorr sqrt(diag(Vbeta)) (beta-bcorr)./sqrt(diag(Vbeta))]; % Note t-value excluding bcorrection
disp('             Coef      Sdev      t-stat')
disp([init,num2str(resul,'% 10.4f')])
disp('R2')
stats(1,1)
disp('LogL')
stats(3,1)
resul(6,1)*1000 % Coefficient pop-density in 3 more digits

% Direct/Indirect effects
px=K;
btemp=beta-bcorr;
[npar dummy]=size(btemp);
beta  = btemp(3:npar-2,1);%%%%%
tau   = btemp(1,1); % Coef Y(t-1)
eta   = btemp(2,1); % Coef WY(t-1)
delta = btemp(npar-1,1); % Coef WY(t)
SS=((1-tau)*eye(N)-(delta+eta)*W)\eye(N);
dirind=zeros(px,3);
for p=1:px
        C=zeros(N,N);
        for i=1:N
            for j=1:N
                if (i==j) C(i,j)=beta(p);
                end
            end
        end
        SC=SS*C;
        dirind(p,1)=xmean(p)*100*sum(diag(SC))/(N*ymean); % average direct effect
        dirind(p,2)=xmean(p)*100*sum(sum(SC,2)-diag(SC))/(N*ymean); % average indirect effect
        dirind(p,3)=dirind(p,1)+dirind(p,2);        
end
dirind
sum(dirind)